<script setup lang="ts">
import { ref } from 'vue'

let id = 0

const newTodo = ref('')
const todos = ref([
  { id: id++, text: 'Learn HTML' },
  { id: id++, text: 'Learn JavaScript' },
  { id: id++, text: 'Learn Vue' }
])

function addTodo() {
  todos.value.push({ id: id++, text: newTodo.value })
  newTodo.value = ''
}

function removeTodo(todo: any) {
  // todos.value = todos.value.filter((t) => t !== todo)
  // todos.value = todos.value.filter(function (t) {
    // return t.id !== id
  // })
    // const index = todos.value.findIndex((t) => t.id ===id)
    // todos.value.splice(index,1)
    const index = todos.value.indexOf(todo)
    todos.value.splice(index,1)
}
</script>

<template>
    <div>{{ todos }}</div>
    <div>{{ newTodo }}</div>
    <input type="text" v-model="newTodo" />
    <button @click="addTodo">Add Todo</button>    
  <ul>
    <li v-for="todo in todos" :key="todo.id">
      {{ todo.text }} <button @click="removeTodo(todo)">X</button>
    </li>
  </ul>
</template>

<style scoped></style>